VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Simple Acquisition"
   ClientHeight    =   1845
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   4035
   LinkTopic       =   "Form1"
   ScaleHeight     =   1845
   ScaleWidth      =   4035
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Start 
      Caption         =   "Start"
      Height          =   375
      Left            =   1320
      TabIndex        =   0
      Top             =   480
      Width           =   1095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim plfVal(0 To 1) As ViReal64
Dim resVal(0 To 2) As ViReal64

'Simple error checking function.
'If an error occured, get the error description and display in a message box.
'Return true if an error occured and false if one did not.
Private Function CheckError(errorCode As ViStatus) As ViBoolean
    If (errorCode < VI_SUCCESS) Then
        Dim errorMessage As String * 256

        Call niSwitch_error_message(VI_NULL, errorCode, errorMessage)
        Call MsgBox(errorMessage, vbCritical, "niSwitch Error")
        CheckError = VI_TRUE
        Exit Function
    End If
    CheckError = VI_FALSE
End Function
Private Sub Start_Click()
    Dim vi As ViSession
    Dim i As ViInt32
   
    'Disable Acquire button until acquistion complete
    Start.Enabled = False

    ' Begin by opening a communication channel to the instrument
    If CheckError(niSwitch_init("SCXI1::4::MATRIX", VI_TRUE, VI_TRUE, _
                                 vi)) Then
        GoTo Error
    End If
    
    ' Close switch c0/r0
    If CheckError(niSwitch_Connect(vi, "c0", "r0")) Then
        GoTo Error
    End If
       
    ' Close switch c1/r2
    If CheckError(niSwitch_Connect(vi, "c1", "r2")) Then
        GoTo Error
    End If
       
    ' Close switch c5/r3
    If CheckError(niSwitch_Connect(vi, "c5", "r3")) Then
        GoTo Error
    End If
       
    ' Close communication channel
    If CheckError(niSwitch_close(vi)) Then
        GoTo Error
    End If
    
Error:
    'Enable acquire button
    Start.Enabled = True

End Sub
Private Sub Form_Load()
    'Initialize the ring controls and set default values

End Sub
'Intercept the keystrokes for the number of measurements control.
'Verify that each character is a number, otherwise beep.
Private Sub numOfMeasurements_KeyPress(KeyAscii As Integer)
    Call ValidateInteger(KeyAscii)
End Sub
'Intercept the keystrokes for the range control.
'Verify that each character is a number or ., otherwize beep.
Private Sub Range_KeyPress(KeyAscii As Integer)
    Call ValidateFloat(KeyAscii)
End Sub
Private Function ValidateInteger(KeyAscii As Integer)
    If Not (IsNumeric(Chr(KeyAscii)) Or KeyAscii = 8) Then
        Call Beep
        KeyAscii = 0
    End If
End Function
Private Function ValidateFloat(KeyAscii As Integer)
    If Not (IsNumeric(Chr(KeyAscii)) Or KeyAscii = 8 Or KeyAscii = 46) Then
        Call Beep
        KeyAscii = 0
    End If
End Function
Private Function CtlVal(control As ComboBox)
    CtlVal = control.ItemData(control.ListIndex)
End Function

