VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Simple Acquisition"
   ClientHeight    =   4065
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   4665
   LinkTopic       =   "Form1"
   ScaleHeight     =   4065
   ScaleWidth      =   4665
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox measurements 
      Height          =   2055
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   1320
      Width           =   1815
   End
   Begin VB.TextBox numOfMeas 
      Height          =   285
      Left            =   2760
      TabIndex        =   1
      Text            =   "4"
      Top             =   840
      Width           =   735
   End
   Begin VB.CommandButton Start 
      Caption         =   "Start"
      Height          =   375
      Left            =   720
      TabIndex        =   0
      Top             =   240
      Width           =   1095
   End
   Begin VB.Label NumberOfMeas 
      Caption         =   "NumberOfMeas"
      Height          =   255
      Left            =   2760
      TabIndex        =   2
      Top             =   600
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim plfVal(0 To 1) As ViReal64
Dim resVal(0 To 2) As ViReal64

'Simple error checking function.
'If an error occured, get the error description and display in a message box.
'Return true if an error occured and false if one did not.
Private Function CheckError(errorCode As ViStatus) As ViBoolean
    If (errorCode < VI_SUCCESS) Then
        Dim errorMessage As String * 256

        Call niSwitch_error_message(VI_NULL, errorCode, errorMessage)
        Call MsgBox(errorMessage, vbCritical, "niSwitch Error")
        CheckError = VI_TRUE
        Exit Function
    End If
    CheckError = VI_FALSE
End Function

Private Sub Start_Click()
    Dim vi1 As ViSession
    Dim vi  As ViSession
    Dim i As ViInt32
    Dim range As ViReal64
    Dim resolution As ViReal64
    Dim numelements As ViInt32
    Dim measurementArray() As ViReal64
    ReDim measurementArray(1 To 4)
    Dim numPointsRead As ViInt32
    Dim minFrequency As ViReal64
    Dim maxFrequency As ViReal64
    
   measurements.Text = ""
   range = 10#
   resolution = 1#
   minFrequency = 20#
   maxFrequency = 20000#
   
    'Disable Acquire button until acquistion complete
    Start.Enabled = False

    'Begin by opening a communication channel to the DMM
    If CheckError(niDMM_init("DAQ::2::INSTR", VI_TRUE, VI_TRUE, vi1)) Then
        GoTo Error
    End If
    
    
    ' Open a communication channel to the SCXI-1127 in slot4
    If CheckError(niSwitch_init("SCXI1::4::INDEP", VI_TRUE, VI_TRUE, _
                                 vi)) Then
        GoTo Error
    End If
    
    'Configure Powerline frequency
   If CheckError(niDMM_SetPowerlineFrequency(vi1, _
                                             NIDMM_VAL_60_HERTZ)) Then
        GoTo Error
    End If
   
   'Call NIDMM_ConfigureMeasurement() to set function, range and res
   If CheckError(niDMM_Configure(vi1, NIDMM_VAL_DC_VOLTS, range, _
                                     resolution, minFrequency, maxFrequency)) Then
        GoTo Error
    End If
    
   'Configure a multipoint acquisition
   If CheckError(niDMM_ConfigureMultiPoint(vi1, numOfMeas, 1, _
                                          NIDMM_VAL_IMMEDIATE, 0#)) Then
        GoTo Error
    End If
    
    ' Close switch #17
    If CheckError(niSwitch_SingleSwitchControl(vi, "ch17", _
                                          NISWITCH_VAL_SWITCH_CLOSE)) Then
        GoTo Error
    End If
    ' Close switch #bc01
    If CheckError(niSwitch_SingleSwitchControl(vi, "bc02", _
                                          NISWITCH_VAL_SWITCH_CLOSE)) Then
        GoTo Error
    End If
    
    ' Close switch #ab0
    If CheckError(niSwitch_SingleSwitchControl(vi, "ab0", _
                                          NISWITCH_VAL_SWITCH_CLOSE)) Then
        GoTo Error
    End If
   
    ' Read measurements using NIDMM_ReadMultiPoint()
    If CheckError(niDMM_ReadMultiPoint(vi1, 10000, numOfMeas, _
                                      measurementArray(1), _
                                 numPointsRead)) Then
        GoTo Error
    End If
     
     'Format and display measurements
        For i = 1 To CInt(numOfMeas.Text)
            measurements.Text = measurements.Text & _
                                Format(measurementArray(i), "##0.000000") & _
                                vbCrLf
        Next i
    
    If CheckError(niSwitch_close(vi)) Then
        GoTo Error
    End If
    If CheckError(niDMM_close(vi1)) Then
        GoTo Error
    End If

Error:
    'Enable acquire button
    Start.Enabled = True

End Sub

Private Sub Form_Load()
    'Initialize the ring controls and set default values

End Sub
'Intercept the keystrokes for the number of measurements control.
'Verify that each character is a number, otherwise beep.
Private Sub numOfMeasurements_KeyPress(KeyAscii As Integer)
    Call ValidateInteger(KeyAscii)
End Sub
'Intercept the keystrokes for the range control.
'Verify that each character is a number or ., otherwize beep.
Private Sub Range_KeyPress(KeyAscii As Integer)
    Call ValidateFloat(KeyAscii)
End Sub
Private Function ValidateInteger(KeyAscii As Integer)
    If Not (IsNumeric(Chr(KeyAscii)) Or KeyAscii = 8) Then
        Call Beep
        KeyAscii = 0
    End If
End Function
Private Function ValidateFloat(KeyAscii As Integer)
    If Not (IsNumeric(Chr(KeyAscii)) Or KeyAscii = 8 Or KeyAscii = 46) Then
        Call Beep
        KeyAscii = 0
    End If
End Function
Private Function CtlVal(control As ComboBox)
    CtlVal = control.ItemData(control.ListIndex)
End Function

