VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Simple Acquisition"
   ClientHeight    =   3690
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   5805
   LinkTopic       =   "Form1"
   ScaleHeight     =   3690
   ScaleWidth      =   5805
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox measurements3 
      Height          =   1575
      Left            =   3600
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   3
      Top             =   1320
      Width           =   1455
   End
   Begin VB.TextBox measurements2 
      Height          =   1575
      Left            =   1920
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Top             =   1320
      Width           =   1455
   End
   Begin VB.TextBox measurements1 
      Height          =   1575
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Top             =   1320
      Width           =   1455
   End
   Begin VB.CommandButton Start 
      Caption         =   "Start"
      Height          =   375
      Left            =   1680
      TabIndex        =   0
      Top             =   360
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "ch2"
      Height          =   255
      Index           =   1
      Left            =   4200
      TabIndex        =   6
      Top             =   1080
      Width           =   495
   End
   Begin VB.Label Label2 
      Caption         =   "ch0"
      Height          =   255
      Left            =   720
      TabIndex        =   5
      Top             =   1080
      Width           =   495
   End
   Begin VB.Label Label1 
      Caption         =   "ch1"
      Height          =   255
      Index           =   0
      Left            =   2520
      TabIndex        =   4
      Top             =   1080
      Width           =   495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim plfVal(0 To 1) As ViReal64
Dim resVal(0 To 2) As ViReal64

'Simple error checking function.
'If an error occured, get the error description and display in a message box.
'Return true if an error occured and false if one did not.
Private Function CheckError(errorCode As ViStatus) As ViBoolean
    If (errorCode < VI_SUCCESS) Then
        Dim errorMessage As String * 256

        Call niSwitch_error_message(VI_NULL, errorCode, errorMessage)
        Call MsgBox(errorMessage, vbCritical, "niSwitch Error")
        CheckError = VI_TRUE
        Exit Function
    End If
    CheckError = VI_FALSE
End Function

Private Sub Start_Click()
    Dim vi As ViSession
    Dim inst As ViSession
    Dim scxichan As String
    Dim j As ViInt32
    Dim range As ViReal64
    Dim resolution As ViReal64
    Dim numelements As ViInt32
    Dim measurementArray() As ViReal64
    ReDim measurementArray(1 To 30)
    Dim numPointsRead As ViInt32
    Dim channel As String
    Dim numOfMeas As ViInt32
    Dim minFrequency As ViReal64
    Dim maxFrequency As ViReal64
    
   scxichan = "sc1!md4!ch0:2->com0;"
   measurements1.Text = ""
   measurements2.Text = ""
   measurements3.Text = ""

   range = 10#
   resolution = 1#
   numOfMeas = 30
   minFrequency = 20#
   maxFrequency = 25000#
   
    'Disable Acquire button until acquistion complete
    Start.Enabled = False

    'NI-SWITCH configurations
   If CheckError(niSwitch_init("SCXI1::4::SCANNER", VI_TRUE, VI_TRUE, _
                               inst)) Then
        GoTo Error
    End If
   If CheckError(niSwitch_ConfigureScanTrigger(inst, 0#, _
            NISWITCH_VAL_REARCONNECTOR_MODULE4, _
            NISWITCH_VAL_NONE)) Then
        GoTo Error
    End If
   If CheckError(niSwitch_ConfigureScanList(inst, scxichan, _
            NISWITCH_VAL_BREAK_BEFORE_MAKE)) Then
        GoTo Error
    End If
   If CheckError(niSwitch_SetContinuousScan(inst, 1)) Then
        GoTo Error
    End If
    
    
    'Begin by opening a communication channel to the DMM
    If CheckError(niDMM_init("DAQ::2::INSTR", VI_TRUE, VI_TRUE, vi)) Then
        GoTo Error
    End If

   'Call NIDMM_ConfigureMeasurement() to set function, range and res
   If CheckError(niDMM_Configure(vi, NIDMM_VAL_DC_VOLTS, _
                range, resolution, minFrequency, maxFrequency)) Then
        GoTo Error
    End If
   
   'Configure Powerline frequency
   If CheckError(niDMM_SetPowerlineFrequency(vi, _
                                        NIDMM_VAL_60_HERTZ)) Then
        GoTo Error
    End If
   
   'Call NIDMM_Configure Trigger() to set STP delay
   If CheckError(niDMM_ConfigureTrigger(vi, NIDMM_VAL_IMMEDIATE, _
                                        0.05)) Then
        GoTo Error
    End If

   'Configure a multipoint acquisition
   If CheckError(niDMM_ConfigureMultiPoint(vi, numOfMeas, 1, _
                                       NIDMM_VAL_IMMEDIATE, 0.05)) Then
        GoTo Error
    End If
   
   'Initiate switch and DMM
    If CheckError(niSwitch_InitiateScan(inst)) Then
        GoTo Error
    End If
   If CheckError(niDMM_Initiate(vi)) Then
        GoTo Error
    End If
   
   'Fetch 30 measurementswith DMM
   If CheckError(niDMM_FetchMultiPoint(vi, 10000, 30, _
                                measurementArray(1), numPointsRead)) Then
        GoTo Error
    End If
    'Format and display measurements
        For j = 1 To 10
            measurements1.Text = measurements1.Text & _
                                Format(measurementArray(j), "##0.000000") & _
                                vbCrLf
                Next j
        For j = 11 To 20
            measurements2.Text = measurements2.Text & _
                                Format(measurementArray(j), "##0.000000") & _
                                vbCrLf
                Next j
        For j = 21 To 30
            measurements3.Text = measurements3.Text & _
                                Format(measurementArray(j), "##0.000000") & _
                                vbCrLf
                Next j
    
   
   'Abort and Close DMM and Switch
   If CheckError(niDMM_Abort(vi)) Then
        GoTo Error
    End If
   If CheckError(niDMM_close(vi)) Then
        GoTo Error
    End If
  
    If CheckError(niSwitch_close(inst)) Then
        GoTo Error
    End If

Error:
    'Enable acquire button
    Start.Enabled = True

End Sub

Private Sub Form_Load()
    'Initialize the ring controls and set default values

End Sub
'Intercept the keystrokes for the number of measurements control.
'Verify that each character is a number, otherwise beep.
Private Sub numOfMeasurements_KeyPress(KeyAscii As Integer)
    Call ValidateInteger(KeyAscii)
End Sub
'Intercept the keystrokes for the range control.
'Verify that each character is a number or ., otherwize beep.
Private Sub Range_KeyPress(KeyAscii As Integer)
    Call ValidateFloat(KeyAscii)
End Sub
Private Function ValidateInteger(KeyAscii As Integer)
    If Not (IsNumeric(Chr(KeyAscii)) Or KeyAscii = 8) Then
        Call Beep
        KeyAscii = 0
    End If
End Function
Private Function ValidateFloat(KeyAscii As Integer)
    If Not (IsNumeric(Chr(KeyAscii)) Or KeyAscii = 8 Or KeyAscii = 46) Then
        Call Beep
        KeyAscii = 0
    End If
End Function
Private Function CtlVal(control As ComboBox)
    CtlVal = control.ItemData(control.ListIndex)
End Function

